#ifndef DGX_MUSIC_H
#define DGX_MUSIC_H

#include <engine/psx.h>

#define CHAN_JUMPJET	0
#define CHAN_MSX98	1
#define CHAN_DURHAM	2

/* error codes */
#define VAB_HEADERFAIL		(1<<0)
#define VAB_BODYTRANSFAIL	(1<<1)

#define DATABUFFER_SIZE		2352

#define CBREADY_CNT_FINISH	UINT_MAX
#define CBREADY_CNT_OVERRUN	(UINT_MAX-1)

struct XAFile
{
	CdlFILE fp;		/* location of file */
	CdlFILTER filter;	/* ADPCM channel */
	char is_playing;
}music;

/*
 * p_currentXA is the XA file being played, which is set in play_XA().
 * play_XA() also automatically sets the previous XA file's is_playing
 * member to 0, while setting the current XA file's is_playing member
 * to 1 (there is no change if it is the same XA file!)
 */
unsigned char data_buffer[DATABUFFER_SIZE];
void cbready(int status, unsigned char *p_result);

/* to be set by the user */
volatile unsigned char *p_cbready_membuf;
volatile unsigned int *p_cbready_nsector;
volatile unsigned int *p_cbready_cnt;
volatile int cbready_fploc;

CdlLOC cd_loc[100];
int cd_ntoc;

#endif

